package dev.fyloz.trial.colorrecipesexplorer.core.exception.model;

import dev.fyloz.trial.colorrecipesexplorer.core.model.IModel;
import lombok.Getter;
import lombok.NonNull;

@Getter
public class EntityAlreadyExistsException extends ModelException {

    @NonNull
    private IdentifierType identifierType;

    private String identifierName;

    @NonNull
    private Object requestedId;

    public EntityAlreadyExistsException(Class<? extends IModel> type, IdentifierType identifierType, Object requestedId) {
        super(type);
        this.identifierType = identifierType;
        this.requestedId = requestedId;
    }

    public EntityAlreadyExistsException(Class<? extends IModel> type, IdentifierType identifierType, String identifierName, Object requestedId) {
        super(type);
        this.identifierType = identifierType;
        this.identifierName = identifierName != null ? identifierName : identifierType.getName();
        this.requestedId = requestedId;
    }
}
