package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;
import org.hibernate.annotations.ColumnDefault;

import javax.persistence.*;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;

@Entity
@Data
@EqualsAndHashCode(callSuper = false)
@RequiredArgsConstructor
@NoArgsConstructor
public class Material implements IModel {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private Long id;

    @NonNull
    @NotNull
    @NotEmpty
    @Column(unique = true)
    private String name;

    @NonNull
    @NotNull
    private Float inventoryQuantity;

    @NonNull
    @NotNull
    private Boolean isMixType;

    @NonNull
    @NotNull
    @ManyToOne
    private MaterialType materialType;

    public boolean isMixType() {
        return isMixType;
    }

}
