package dev.fyloz.trial.colorrecipesexplorer.web.controller;

import dev.fyloz.trial.colorrecipesexplorer.core.io.response.JSONResponseBuilder;
import dev.fyloz.trial.colorrecipesexplorer.core.io.response.ModelResponseBuilder;
import dev.fyloz.trial.colorrecipesexplorer.core.io.response.ResponseCode;
import dev.fyloz.trial.colorrecipesexplorer.core.io.response.ResponseDataType;
import dev.fyloz.trial.colorrecipesexplorer.core.model.Material;
import dev.fyloz.trial.colorrecipesexplorer.core.model.Mix;
import dev.fyloz.trial.colorrecipesexplorer.core.model.MixQuantity;
import dev.fyloz.trial.colorrecipesexplorer.core.services.InventoryService;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MaterialService;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MaterialTypeService;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MixService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;
import java.util.stream.Collectors;

import static dev.fyloz.trial.colorrecipesexplorer.web.StringBank.RESPONSE_REASON;
import static dev.fyloz.trial.colorrecipesexplorer.web.WebsitePaths.INVENTORY;
import static dev.fyloz.trial.colorrecipesexplorer.web.WebsitePaths.USE_INVENTORY;

@Controller
public class InventoryController {

    private InventoryService inventoryService;
    private MaterialService materialService;
    private MixService mixService;
    private MaterialTypeService materialTypeService;

    @Autowired
    public InventoryController(InventoryService inventoryService, MaterialService materialService, MixService mixService, MaterialTypeService materialTypeService) {
        this.inventoryService = inventoryService;
        this.materialService = materialService;
        this.mixService = mixService;
        this.materialTypeService = materialTypeService;
    }

    @GetMapping(INVENTORY)
    public ModelAndView getPage(ModelAndView model) {
        return new ModelResponseBuilder(model)
                .withView(INVENTORY)
                .addResponseData(ResponseDataType.MATERIALS, materialService.getAllOrdered().stream().filter(m -> !m.isMixType()).collect(Collectors.toList()))
                .addResponseData(ResponseDataType.MATERIAL_TYPES, materialTypeService.getAll())
                .build();
    }

    @PostMapping(value = USE_INVENTORY, consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    @ResponseBody
    @Transactional
    // TODO vers DTO
    // TODO + vers service
    public Map<String, Object> consumeMaterials(@RequestBody Map<String, Map<String, Float>> form) {
        throw new UnsupportedOperationException("TODO");

//        JSONResponseBuilder responseBuilder = new JSONResponseBuilder();
//
//        List<Mix> mixes = new ArrayList<>();
//        Map<Mix, Map<Material, Float>> quantities = new HashMap<>();
//
//        for (String mixIDStr : form.keySet()) {
//            Long mixID = Long.parseLong(mixIDStr);
//
//            Optional<Mix> optionalMix = mixService.getById(mixID);
//            if (optionalMix.isEmpty()) {
//                return responseBuilder
//                        .addResponseCode(ResponseCode.MIX_NOT_FOUND, mixID)
//                        .build();
//            }
//
//            Mix mix = optionalMix.get();
//            mixes.add(mix);
//
//            Map<String, Float> formMaterials = form.get(mixIDStr);
//            Map<Material, Float> mixQuantities = new HashMap<>();
//
//            for (Material material : mix.getMixQuantities().stream().map(MixQuantity::getMaterial).collect(Collectors.toList())) {
//                String materialIDAsString = String.valueOf(material.getId());
//
//                if (formMaterials.containsKey(materialIDAsString)) {
//                    Float quantityAsString = formMaterials.get(materialIDAsString);
//                    mixQuantities.put(material, quantityAsString);
//                }
//            }
//
//            quantities.put(mix, mixQuantities);
//        }
//
//        for (Mix mix : mixes) {
//            String errorCode = inventoryService.checkQuantities(mix, quantities.get(mix));
//            if (errorCode != null) {
//                String materialCode = materialService.getById(Long.parseLong(errorCode.split("-")[1])).orElse(new Material()).getName();
//
//                return responseBuilder
//                        .addResponseCode(ResponseCode.NOT_ENOUGH_MATERIAL, materialCode)
//                        .addAttribute(RESPONSE_REASON, errorCode)
//                        .build();
//            }
//        }
//
//        for (Mix mix : mixes) {
//            if (!inventoryService.useMix(quantities.get(mix))) {
//                return responseBuilder
//                        .addResponseCode(ResponseCode.ERROR_SAVING)
//                        .build();
//            }
//        }
//
//        return responseBuilder
//                .addResponseCode(ResponseCode.SUCCESS_USING_MATERIALS)
//                .build();
    }
}
